# 2.4.x Stable Releases

See https://www.pantsbuild.org/v2.4/docs/release-notes-2-4 for an overview of the changes in this release series.

## 2.4.2 (June 16, 2021)

The third stable release of the `2.4.x` series, with no changes since the previous `rc`.

## 2.4.2rc1 (Jun 02, 2021)

### Bug fixes

* Fix `Key` interning race causing `panic while processing panic` failure (Cherry-pick of #12152) ([#12159](https://github.com/pantsbuild/pants/pull/12159))

## 2.4.2rc0 (May 25, 2021)

### Performance

* Halve memory usage for remote cache writes (Cherry-pick of #12083) ([#12118](https://github.com/pantsbuild/pants/pull/12118))

### Documentation

* Rewrite error message when Pantsd is shut down during run (Cherry-pick of #12107) ([#12117](https://github.com/pantsbuild/pants/pull/12117))

## 2.4.1 (May 6, 2021)

The second stable release of the `2.4.x` series, with no changes since the previous `rc`.

## 2.4.1rc1 (Apr 29, 2021)

### User API Changes

* Add back `interpreter_constraints` field to `pex_binary` and `python_awslambda` ([#11979](https://github.com/pantsbuild/pants/pull/11979))

* Revert "Run MyPy only on specified files, not transitive closure" ([#11969](https://github.com/pantsbuild/pants/pull/11969))

### Documentation

* Make remote cache warning less chatty for missing files (Cherry-pick of #11976) ([#11983](https://github.com/pantsbuild/pants/pull/11983))

## 2.4.1rc0 (Apr 20, 2021)

### User API Changes

* Run MyPy only on specified files, not transitive closure (Cherry-pick of #11936) ([#11938](https://github.com/pantsbuild/pants/pull/11938))

### Bug fixes

* Fix remote cache writes to not block the Pants run (Cherry-pick of #11947) ([#11950](https://github.com/pantsbuild/pants/pull/11950))

## 2.4.0 (Apr 19, 2021)

The first stable release of the `2.4.x` series, with no changes since the previous `rc`!

## 2.4.0rc5 (Apr 17, 2021)

### Bug fixes

* Wait for all Sessions during pantsd shutdown (cherrypick of #11929) ([#11934](https://github.com/pantsbuild/pants/pull/11934))

* Retrieve RunTracker args from the OptionsBootstrapper. (cherrypick of #11931) ([#11932](https://github.com/pantsbuild/pants/pull/11932))

## 2.4.0rc4 (Apr 14, 2021)

### Bug fixes

* Allow Python files without a file ending (Cherry-pick of #11905) ([#11916](https://github.com/pantsbuild/pants/pull/11916))

* Fix bug in Python 2.7 string dep inference. (Cherry-pick of #11900) ([#11904](https://github.com/pantsbuild/pants/pull/11904))

* Fix remote cache storing of `output_directories` (Cherry-pick of #11895) ([#11896](https://github.com/pantsbuild/pants/pull/11896))

## 2.4.0rc3 (Apr 10, 2021)

### Bug fixes

* Fix a bug in unicode string dep inference. (cherrypick of #11879) ([#11883](https://github.com/pantsbuild/pants/pull/11883))

## 2.4.0rc2 (Apr 08, 2021)

### New Features

* Add `--remote-cache-warnings` and make remote cache warnings less chatty (Cherry-pick of #11859) ([#11863](https://github.com/pantsbuild/pants/pull/11863))

## 2.4.0rc1 (Apr 05, 2021)

### Bug fixes

* Fix transitive excludes for generating setup.py (Cherry-pick of #11811) ([#11839](https://github.com/pantsbuild/pants/pull/11839))

### Documentation

* Escape generated markdown values (Cherry-pick of #11841) ([#11846](https://github.com/pantsbuild/pants/pull/11846))

* Fix typo in `tags` help message (Cherry-pick of #11838) ([#11837](https://github.com/pantsbuild/pants/pull/11837))

## 2.4.0rc0 (Mar 25, 2021)

### New Features

* Warn when dependency inference is not used due to ambiguity from >1 target exporting the same Python module. ([#11792](https://github.com/pantsbuild/pants/pull/11792))

* Dependency inference: can disambiguate modules with multiple owners via `!` ignores ([#11786](https://github.com/pantsbuild/pants/pull/11786))

### User API Changes

* Deprecate `--process-execution-cleanup-local-dirs` in favor of `--process-execution-local-cleanup` ([#11785](https://github.com/pantsbuild/pants/pull/11785))

* Deprecate `--process-execution-use-local-cache` in favor of `--process-execution-local-cache` ([#11781](https://github.com/pantsbuild/pants/pull/11781))

### Bug fixes

* Do not infer dependencies in some edge cases with ambiguity ([#11780](https://github.com/pantsbuild/pants/pull/11780))

* Ensure that metrics are gathered during abnormal exits ([#11793](https://github.com/pantsbuild/pants/pull/11793))

* Enable configuration of local store size limits ([#11777](https://github.com/pantsbuild/pants/pull/11777))

* Fix remote execution of Pexes by properly using `append_only_caches`. ([#11760](https://github.com/pantsbuild/pants/pull/11760))

## 2.4.0.dev3 (Mar 19, 2021)

### New Features

* Add support for gRPC mypy stub files ([#11658](https://github.com/pantsbuild/pants/pull/11658))

* Support extra test runner output. ([#11741](https://github.com/pantsbuild/pants/pull/11741))

* Send opt-in anonymous telemetry to bugout ([#11697](https://github.com/pantsbuild/pants/pull/11697))

* Add `[python-setup].requirement_constraints_target` for upcoming Poetry macro ([#11724](https://github.com/pantsbuild/pants/pull/11724))

### User API Changes

* Kill `SETTABLE_ENV_VARS` allow list. ([#11743](https://github.com/pantsbuild/pants/pull/11743))

### Plugin API Changes

* Implement the IO methods required for `input`, and add `Console.input`. ([#11703](https://github.com/pantsbuild/pants/pull/11703))

* Mutually exclusive options no longer change the `dest` ([#11718](https://github.com/pantsbuild/pants/pull/11718))

### Bug fixes

* Invalidate all files in the graph when file watching receives a rescan event. ([#11734](https://github.com/pantsbuild/pants/pull/11734))

* Fix a deadlock involving `scheduler.all_digests`, and add a note. ([#11723](https://github.com/pantsbuild/pants/pull/11723))

* Fix source root stripping to not strip `requirements.txt` files in plugins ([#11712](https://github.com/pantsbuild/pants/pull/11712))

* Fix the mypy-protobuf interpreter constraint. ([#11695](https://github.com/pantsbuild/pants/pull/11695))

### Documentation

* Make `-ldebug` less chatty when using remote caching ([#11667](https://github.com/pantsbuild/pants/pull/11667))

* Improve error message for unmatched globs ([#11699](https://github.com/pantsbuild/pants/pull/11699))

## 2.4.0.dev2 (Mar 12, 2021)

### New Features

* Add a default `module_mapping` for Python 3rd-party dependency inference. ([#11635](https://github.com/pantsbuild/pants/pull/11635))

### User API Changes

* Warn when depending on `files` targets in a `pex_binary` or `python_awslambda` ([#11659](https://github.com/pantsbuild/pants/pull/11659))

* Bump default for `[python-protobuf].mypy_plugin_version` to 2.4 ([#11662](https://github.com/pantsbuild/pants/pull/11662))

### Plugin API Changes

* Require subclassing `WorkunitsCallback` ([#11677](https://github.com/pantsbuild/pants/pull/11677))

### Bug fixes

* Fix the `local_only` option to properly disable remote execution and caching ([#11678](https://github.com/pantsbuild/pants/pull/11678))

* Fix PYTHONPATH not including protobuf targets using `python_source_root`  ([#11673](https://github.com/pantsbuild/pants/pull/11673))

* Fix streaming workunit handler plugins to log to console during run ([#11674](https://github.com/pantsbuild/pants/pull/11674))

* Avoid std::io::std usage in UI fallback. ([#11671](https://github.com/pantsbuild/pants/pull/11671))

* Improve phrasing for "unknown goal" and "unknown flag" errors. ([#11664](https://github.com/pantsbuild/pants/pull/11664))

* Do not interpret passthrough args. ([#11656](https://github.com/pantsbuild/pants/pull/11656))

### Performance

* Streaming workunit handler can finalize async when pantsd used ([#11683](https://github.com/pantsbuild/pants/pull/11683))

## 2.4.0.dev1 (Mar 08, 2021)

### New Features

* Add support for Pytest config files ([#11624](https://github.com/pantsbuild/pants/pull/11624))

### Plugin API Changes

* Add Python tool support for console scripts. ([#11620](https://github.com/pantsbuild/pants/pull/11620))

* Require explicit environment usage ([#11641](https://github.com/pantsbuild/pants/pull/11641))

### Bug fixes

* Upgrade to Pex 2.1.33 to fix `et-xmlfile` issue. ([#11647](https://github.com/pantsbuild/pants/pull/11647))

* Ensure that ancestor files at the buildroot are found. ([#11632](https://github.com/pantsbuild/pants/pull/11632))

* Handle two edge cases with `./pants tailor` ([#11625](https://github.com/pantsbuild/pants/pull/11625))

### Documentation

* Wrap `./pants help` based on actual terminal width ([#11378](https://github.com/pantsbuild/pants/pull/11378))

* Fix references to the deprecated pants log location. ([#11636](https://github.com/pantsbuild/pants/pull/11636))

## 2.4.0.dev0 (Feb 27, 2021)

### New Features

* Add `--stats-log` to log metrics at end of run ([#11599](https://github.com/pantsbuild/pants/pull/11599))

### User API Changes

* Deprecate --python-setup-resolver-version option. ([#11611](https://github.com/pantsbuild/pants/pull/11611))

* Remove deprecated --remote-store options. ([#11609](https://github.com/pantsbuild/pants/pull/11609))

* Remove deprecated --process-execution-speculation options. ([#11610](https://github.com/pantsbuild/pants/pull/11610))

* Remove deprecated `--remote-execution-server` and `--remote-store-server` options ([#11603](https://github.com/pantsbuild/pants/pull/11603))

* Deprecate unused `--process-execution-local-enable-nailgun` ([#11600](https://github.com/pantsbuild/pants/pull/11600))

### Bug fixes

* Upgrade Pex to 2.1.32 to fix venv script shebangs being too long for some Linux systems. ([#11604](https://github.com/pantsbuild/pants/pull/11604))

### Performance

* Release the Pants PEX in `--venv` mode. ([#11591](https://github.com/pantsbuild/pants/pull/11591))

### Documentation

* Less chatty plugin resolution logging ([#11593](https://github.com/pantsbuild/pants/pull/11593))

